import"reflect-metadata";import{isArray,has,isUndefined,isObject,map,cloneDeep,replace,find,isString,capitalize,get,set,unset,isFunction,uniq,flattenDeep,compact,defaultsDeep}from"lodash";import{resolve,all,reject,method}from"bluebird";import{Errors}from"moleculer";import{ConnectionNotFoundError,DataSource,AlreadyHasActiveConnectionError,In}from"typeorm";import{ObjectId}from"mongodb";import{flatten}from"flat";class ConnectionManager{get connections(){return Array.from(this.connectionMap.values())}connectionMap=new Map;has(e){return this.connectionMap.has(e)}get(e="default"){var t=this.connectionMap.get(e);if(t)return t;throw new ConnectionNotFoundError(e)}remove(e="default"){if(!this.connectionMap.get(e))throw new ConnectionNotFoundError(e);this.connectionMap.delete(e)}async close(e="default"){const t=e=>{throw new ConnectionNotFoundError(e)},r=async e=>{await this.connectionMap.get(e).destroy(),this.remove(e)};return!isArray(e)&&this.connectionMap.has(e)?await r(e).then(()=>!0).catch(()=>!1):isArray(e)?e.map(async e=>this.connectionMap.has(e)?await r(e).then(()=>!0).catch(()=>!1):t(e)):t(e)}async create(t,e=!1){var r=this.connectionMap.get(t.name||"default");let i;return e&&!r?new TypeORMDbAdapter(t):(e=r&&r.isInitialized?(()=>{var e=new AlreadyHasActiveConnectionError(t.name||"default");throw new Errors.MoleculerServerError(e.message,500,"ERR_CONNECTION_ALREADY_EXIST")})():new DataSource(t),i=await e.initialize().then(e=>e).catch(e=>{throw new Errors.MoleculerServerError(e.message,500,"ERR_CONNECTION_CREATE")}),this.connectionMap.set(e.name,e),resolve(i))}}class TypeORMDbAdapter{connectionManager;_entity;manager;repository;constructor(e){this.opts=e}init(e,t){this.broker=e,this.service=t;e=this.service.schema.model;const r=[];has(this.opts,"entities")?this._entity=[...this.opts.entities]:isArray(e)?(e.forEach(e=>{e.constructor||new Errors.MoleculerServerError("Invalid model. It should be a typeorm repository"),r.push(e)}),this._entity=r):!isUndefined(e)&&e.constructor?this._entity=e:new Errors.MoleculerServerError("Invalid model. It should be a typeorm repository")}async connect(){this.connectionManager=new ConnectionManager;const l=await this.connectionManager.create(this.opts);this.broker.logger.info(`${this.service.name} has connected to ${l.name} database`);var e=isArray(this._entity)?this._entity:[this._entity];e.forEach((t,r)=>{const i=l.manager.getRepository(t),e=l.manager;var s,n=i.metadata.name,o=([s={}]=[t],Object.getOwnPropertyNames(s).filter(e=>"function"==typeof s[e]));const a={manager:e,repository:i,getRepository:function(){if(l)return e.getRepository(t);throw new Error("DataSource is not set for this entity.")}};o.forEach(e=>{0===r?this[e]=t[e]:a[e]=t[e]}),["hasId","save","remove","softRemove","recover","reload","useDataSource","getRepository","metadata","target","getId","createQueryBuilder","create","merge","preload","insert","update","upsert","delete","count","countBy","sum","average","minimum","maximum","find","findBy","findAndCount","findAndCountBy","findOne","findOneBy","findOneOrFail","findOneByOrFail","query","clear","createCursor","createEntityCursor","aggregate","aggregateEntity","bulkWrite","createCollectionIndex","createCollectionIndexes","deleteMany","deleteOne","distinct","dropCollectionIndex","dropCollectionIndexes","findOneAndDelete","findOneAndReplace","findOneAndUpdate","geoHaystackSearch","geoNear","group","collectionIndexes","collectionIndexExists","collectionIndexInformation","initializeOrderedBulkOp","initializeUnorderedBulkOp","insertMany","insertOne","isCapped","listCollectionIndexes","parallelCollectionScan","reIndex","rename","replaceOne","stats","updateMany","updateOne"].forEach(e=>{i[e]&&(0===r?"hasId"===e||"getRepository"===e||"target"===e||"metadata"===e||"useDataSource"===e||"getId"===e?this[e]=i[e]:this["_"+e]=i[e]:"hasId"===e||"getRepository"===e||"target"===e||"metadata"===e||"useDataSource"===e||"getId"===e?a[e]=i[e]:a["_"+e]=i[e])}),i.save?0!==r&&(this[n]={...a,create:this.create,findByIdWO:this.findByIdWO,findById:this.findById,getPopulations:this.getPopulations,count:this.count,find:this.find,findOne:this.findOne,list:this.list,encodeID:this.encodeID,decodeID:this.decodeID,toMongoObjectId:this.toMongoObjectId,fromMongoObjectId:this.fromMongoObjectId,transformDocuments:this.transformDocuments,beforeEntityChange:this.beforeEntityChange,entityChanged:this.entityChanged,clearCache:this.clearCache,filterFields:this.filterFields,excludeFields:this.excludeFields,_excludeFields:this._excludeFields,populateDocs:this.populateDocs,validateEntity:this.validateEntity,entityToObject:this.entityToObject,beforeSaveTransformID:this.beforeSaveTransformID,beforeQueryTransformID:this.beforeQueryTransformID,afterRetrieveTransformID:this.afterRetrieveTransformID,authorizeFields:this.authorizeFields,updateById:this.updateById,broker:this.broker,service:this.service}):this.broker.logger.warn(`Entity class ${n} does not extend TypeORM BaseEntity.
						If you are not using MongoDB, use data mapping with this.adapter.repository or this.adapter.manager instead of active record methodology.`)}),this.manager=l.manager,this.repository=l.manager.getRepository(isArray(this._entity)?this._entity[0]:this._entity),this.dataSource=l}disconnect(){return this.connectionManager.connections.forEach(async t=>{this.broker.logger.info(`Attempting to disconnect from database ${t.name}...`),await this.connectionManager.close(t.name).then(e=>!0===e?this.broker.logger.info("Disconnected from database "+t.name):this.broker.logger.info("Failed to disconnect from database "+t.name)).catch(e=>{this.broker.logger.error("Failed to disconnect from database "+e),new Errors.MoleculerServerError("Failed to disconnect from database "+e,500,"FAILED_TO_DISCONNECT_FROM_DATABASE",e)})}),resolve()}async create(t,e,r){this.broker.logger.debug("Transforming entity id...");const i=this.beforeSaveTransformID(e,this.service.settings.idField);return this.broker.logger.debug("Attempting to create entity: "+i),this._save(i,r).then(async e=>(this.broker.logger.debug("Transforming created entity..."),this.transformDocuments(t,t.params,e))).catch(e=>{this.broker.logger.error("Failed to create entity: "+e),new Errors.MoleculerServerError("Failed to create entity: "+i,500,"FAILED_TO_CREATE_ENTITY",e)})}insert(t,e,r){return resolve().then(()=>isArray(e)?all(e.map(e=>this.beforeEntityChange("create",e,t))).then(e=>(this.broker.logger.debug("Validating entities to create: "+e),this.validateEntity(e))).then(e=>all(e.map(e=>this.beforeEntityChange("create",e,t)))).then(e=>"_id"===this.service.settings.idField?e:e.map(e=>(this.broker.logger.debug("Transforming entity id..."),this.beforeSaveTransformID(e,this.service.settings.idField)))).then(async e=>"mongodb"!==this.opts.type?(this.broker.logger.debug("Attempting to create entities: "+e),await this._insert(e)):(this.broker.logger.debug("Attempting to create mongodb entities: "+e),await this._insertMany(e,r))).then(async e=>this.findById(t,null,Object.entries(e.insertedIds).map(e=>e[1]))).then(e=>this.transformDocuments(t,t.params,e)):!isArray(e)&&isObject(e)?this.beforeEntityChange("create",e,t).then(e=>this.validateEntity(e)).then(e=>this.beforeSaveTransformID(e,this.service.settings.idField)).then(async e=>"mongodb"!==this.opts.type?(this.broker.logger.debug("Attempting to create entity: "+e),await this._insert(e)):(this.broker.logger.debug("Attempting to create mongodb entity: "+e),await this._insertOne(e,r))).then(async e=>this.findById(t,null,e.insertedId)):reject(new Errors.MoleculerClientError("Invalid request! The 'params' must contain 'entityOrEntities'!",400))).then(e=>this.transformDocuments(t,t.params,e)).then(e=>this.entityChanged("created",e,t).then(()=>e))}async updateById(t,r,e){const i=this.sanitizeParams(t,e);this.broker.logger.debug(`Updating entity by ID '${r}' with `+JSON.stringify(i));e=this.repository.metadata.ownColumns[0].entityMetadata.updateDateColumn,isUndefined(e)||"mongodb"!==this.opts.type||(i[e.propertyName]=new Date),e=await this._update("mongodb"!==this.opts.type?r:this.toMongoObjectId(r),i).then(async e=>{this.broker.logger.debug(`Updated entity by ID '${r}': `+e);e=await this.findById(t,null,r);return this.broker.logger.debug("Transforming update docs..."),this.transformDocuments(t,i,e)}).catch(e=>{this.broker.logger.error("Failed to updateById "+e),new Errors.MoleculerServerError("Failed to updateById "+e,500,"FAILED_TO_UPDATE_BY_ID",e)});return this.afterRetrieveTransformID(e,this.service.settings.idField)}async removeById(e){var t=this.beforeQueryTransformID(e);return"mongodb"!==this.opts.type?await this._delete({[t]:e}).catch(e=>{this.broker.logger.error("Failed to updateById "+e),new Errors.MoleculerServerError("Failed to updateById "+e,500,"FAILED_TO_UPDATE_BY_ID",e)}):await this._deleteOne({[t]:this.toMongoObjectId(e)}).catch(e=>{this.broker.logger.error("Failed to updateById "+e),new Errors.MoleculerServerError("Failed to updateById "+e,500,"FAILED_TO_UPDATE_BY_ID",e)})}async count(e,t){return"mongodb"!==this.opts.type?await this._count(e):await this._count(t,e)}async find(t){const r=this.sanitizeParams(t,t.params);return this._find(r).then(e=>(this.broker.logger.debug("Transforming find docs..."),this.transformDocuments(t,r,e))).catch(e=>{this.broker.logger.error("Failed to find "+e),new Errors.MoleculerServerError("Failed to find "+e,500,"FAILED_TO_FIND_ONE_BY_OPTIONS",e)})}async findOne(t,e){const r=this.sanitizeParams(t,t.params);e=await this._findOne(e).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,r,e))).catch(e=>{this.broker.logger.error("Failed to findByIdWO "+e),new Errors.MoleculerServerError("Failed to findByIdWO "+e,500,"FAILED_TO_FIND_ONE_BY_OPTIONS",e)});return this.afterRetrieveTransformID(e,this.service.settings.idField)}async findByIdWO(t,e=this.service.settings.idField,r,i){e=this.beforeQueryTransformID(e);const s=this.sanitizeParams(t,t.params);e="mongodb"!==this.opts.type?isArray(r)?await this._find({where:{[e]:In([...r])},...i}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,s,e))).catch(e=>{this.broker.logger.error("Failed to findByIdWO "+e),new Errors.MoleculerServerError("Failed to findByIdWO "+e,500,"FAILED_TO_FIND_BY_ID_WO",e)}):await this._findOneOrFail({where:{[e]:In([r])},...i}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,s,e))).catch(e=>{this.broker.logger.error("Failed to findByIdWO "+e),new Errors.MoleculerServerError("Failed to findByIdWO "+e,500,"FAILED_TO_FIND_BY_ID_WO",e)}):isArray(r)?await this._find({where:{[e]:{$in:[...map(r,e=>this.toMongoObjectId(e))]},...i}}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,s,e))).catch(e=>{this.broker.logger.error("Failed to findByIdWO "+e),new Errors.MoleculerServerError("Failed to findByIdWO "+e,500,"FAILED_TO_FIND_BY_ID_WO",e)}):await this._findOneOrFail({where:{[e]:{$in:[this.toMongoObjectId(r)]}},...i}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,s,e))).catch(e=>{this.broker.logger.error("Failed to findByIdWO "+e),new Errors.MoleculerServerError("Failed to findByIdWO "+e,500,"FAILED_TO_FIND_BY_ID_WO",e)});return this.afterRetrieveTransformID(e,this.service.settings.idField)}async findById(t,e=this.service.settings.idField,r){e=this.beforeQueryTransformID(e);const i=this.sanitizeParams(t,t.params);return"mongodb"!==this.opts.type?isArray(r)?await this._findBy({[e]:In([...r])}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,i,e))).catch(e=>{this.broker.logger.error("Failed to findById "+e),new Errors.MoleculerServerError("Failed to findById "+e,500,"FAILED_TO_FIND_BY_ID",e)}):await this._findOneByOrFail({[e]:In([r])}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,i,e))).catch(e=>{this.broker.logger.error("Failed to findById "+e),new Errors.MoleculerServerError("Failed to findById "+e,500,"FAILED_TO_FIND_BY_ID",e)}):isArray(r)?await this._find({where:{[e]:{$in:[...map(r,e=>this.toMongoObjectId(e))]}}}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,i,e))).catch(e=>{this.broker.logger.error("Failed to findById "+e),new Errors.MoleculerServerError("Failed to findById "+e,500,"FAILED_TO_FIND_BY_ID",e)}):await this._findOneByOrFail({where:{[e]:{$in:[this.toMongoObjectId(r)]}}}).then(e=>(this.broker.logger.debug("Transforming findByIdWO docs..."),this.transformDocuments(t,i,e))).catch(e=>{this.broker.logger.error("Failed to findById "+e),new Errors.MoleculerServerError("Failed to findById "+e,500,"FAILED_TO_FIND_BY_ID",e)})}getPopulations(t,i){let r=i.id,s,n=!0===i.mapping;return this.findById(t,null,r).then(e=>e?(s=n?isArray(e)?e.map(e=>cloneDeep(e)):cloneDeep(e):e,this.transformDocuments(t,i,e)):Promise.reject(new Errors.MoleculerServerError("Failed to findById "+r,500,"FAILED_TO_FIND_BY_ID"))).then(e=>{if(!0!==i.mapping)return e;let r={};var t;return isArray(e)?e.forEach((e,t)=>{t=this.encodeID(this.afterRetrieveTransformID(s[t],this.service.settings.idField)[this.service.settings.idField]);r[t]=e}):isObject(e)&&(t=this.encodeID(this.afterRetrieveTransformID(s,this.service.settings.idField)[this.service.settings.idField]),r[t]=e),r})}list(e,r){var t=this.sanitizeParams(e,r),t=Object.assign({},t);t?.limit&&(t.limit=void 0),t?.offset&&(t.offset=void 0),null==r.limit&&(0<this.service.settings.limit&&r.pageSize>this.service.settings.limit?r.limit=this.service.settings.limit:r.limit=r.pageSize);let i;r.take&&r.skip?(r.limit&&delete r.limit,r.offset&&delete r.offset,i=r):(r.limit||r.offset)&&(i=JSON.parse(replace(JSON.stringify(r),'"limit":','"take":').replace('"offset":','"skip":'))),has(i,"relations")&&"string"==typeof i.relations&&(i.relations=JSON.parse(i.relations)),has(i,"where")&&"string"==typeof i.where&&(i.where=JSON.parse(i.where));let s;return t.take&&t.skip&&(t.limit&&delete t.limit,t.offset&&delete t.offset,0!==r.offset)&&(s=t),r.limit&&r.offset&&0!==r.offset&&(s=JSON.parse(replace(JSON.stringify(t),'"limit":','"take":').replace('"offset":','"skip":'))),has(s,"relations")&&delete s.relations,has(s,"where")&&"string"==typeof s.where&&(s.where=JSON.parse(s.where)),delete i.pageSize,delete i.page,s&&(delete s.pageSize,delete s.page),all([this._find(i),this._count(s)]).then(async t=>this.transformDocuments(e,r,t[0]).then(e=>({rows:e,total:t[1],page:r.page,pageSize:r.pageSize,totalPages:Math.floor((t[1]+r.pageSize-1)/Number(r.pageSize))})))}beforeSaveTransformID(e,t){let r=cloneDeep(e);var i="mongodb"===this.opts.type?"_id":find(this.repository.metadata.ownColumns,{isPrimary:!0}).propertyName;return r=t!==i&&void 0!==e[t]?JSON.parse(replace(JSON.stringify(r),new RegExp(`"${t}":`,"g"),`"${i}":`)):r}afterRetrieveTransformID(e,t){var r=find(this.repository.metadata.ownColumns,{isPrimary:!0}).propertyName;let i;return i=e.hasOwnProperty(t)?e:JSON.parse(replace(JSON.stringify(e),new RegExp(`"${r}":`,"g"),`"${t}":`))}encodeID(e){return e}toMongoObjectId(e){return new ObjectId(e)}fromMongoObjectId(e){return e.toString()}beforeQueryTransformID(e){var t="mongodb"===this.opts.type?"_id":find(this.repository.metadata.ownColumns,{isPrimary:!0}).propertyName;return e!==t?t:e}decodeID(e){return e}transformDocuments(i,s,e){this.broker.logger.debug("Transforming documents..");let t=!1;this.broker.logger.debug("Setting userDefinedIDField to "+this.service.settings.idField);const r=this.service.settings.idField;if(this.broker.logger.debug("Checking if docs is an array or an object.."),!Array.isArray(e)){if(this.broker.logger.debug("Docs is not an array"),!isObject(e))return this.broker.logger.debug("Docs is not an object, returning docs.."),resolve(e);this.broker.logger.debug("Docs is an object, converting to array.."),t=!0,e=[e]}return resolve(e).then(e=>e.map(e=>(this.broker.logger.debug("Converting entity to JS object..."),this.entityToObject(e)))).then(e=>e.map(e=>(this.broker.logger.debug("Applying idField to docs..."),this.afterRetrieveTransformID(e,r)))).then(e=>e.map(e=>(this.broker.logger.debug("Encoding IDs.."),e[r]=this.encodeID(e[r]),e))).then(e=>(this.broker.logger.debug(`Populating docs with ${s.populate}..`),i&&s.populate?this.populateDocs(i,e,s.populate):e)).then(e=>{if(this.broker.logger.debug("Attempting to filter fields.."),i&&s.fields){this.broker.logger.debug("Fields found in params..");var t=isString(s.fields)?s.fields.split(/\s+/):s.fields;this.broker.logger.debug("Authorizing fields..");const r=this.authorizeFields(t);return this.broker.logger.debug("Filtering fields and returning object.."),e.map(e=>this.filterFields(e,r))}return this.broker.logger.debug("No fields found in params, returning filtered object.."),e.map(e=>this.filterFields(e,this.service.settings.fields))}).then(e=>{this.broker.logger.debug("Attempting to filter excludeFields..");const t=(i&&s.excludeFields?isString(s.excludeFields)?s.excludeFields.split(/\s+/):s.excludeFields:[]).concat(this.service.settings.excludeFields||[]);return Array.isArray(t)&&0<t.length?(this.broker.logger.debug("ExcludeFields found in params, returning filtered object.."),e.map(e=>this._excludeFields(e,t))):(this.broker.logger.debug("No excludeFields found in params, returning object.."),e)}).then(e=>(this.broker.logger.debug("Returning json object.."),t?e[0]:e)).catch(e=>{throw this.broker.logger.error("Transforming documents is failed!",e),new Errors.MoleculerServerError("Failed to transform documents "+e,500,"FAILED_TO_TRANSFORM_DOCUMENTS",e)})}beforeEntityChange(e,t,r){e="beforeEntity"+capitalize(e);return null==this.service.schema[e]?resolve(t):resolve(this.service.schema[e].call(this,t,r))}async entityChanged(t,r,i){return this.clearCache().then(async()=>{var e="entity"+capitalize(t);if(null!=this.service.schema[e])return this.service.schema[e].call(this,r,i)})}clearCache(){return this.broker[this.service.settings.cacheCleanEventType]("cache.clean."+this.fullName),this.broker.cacher?this.broker.cacher.clean(this.fullName+".**"):resolve()}filterFields(i,e){if(Array.isArray(e)){let r={};return e.forEach(e=>{var t=get(i,e);void 0!==t&&set(r,e,t)}),r}return i}excludeFields(e,t){return Array.isArray(t)&&0<t.length?this._excludeFields(e,t):e}_excludeFields(e,t){const r=cloneDeep(e);return t.forEach(e=>{unset(r,e)}),r}populateDocs(t,r,e){if(this.broker.logger.debug("Attempting to populate documents.."),!this.service.settings.populates||!Array.isArray(e)||0==e.length)return this.broker.logger.debug("No populateFields found, returning docs.."),resolve(r);if(null==r||!isObject(r)&&!Array.isArray(r))return this.broker.logger.debug("No docs found, returning docs.."),resolve(r);this.broker.logger.debug("Setting settingPopulateFields with "+Object.keys(this.service.settings.populates));const i=Object.keys(this.service.settings.populates);this.broker.logger.debug("Grouping populateFields..");var n=e.reduce((e,t)=>{this.broker.logger.debug(`Checking if ${t} is in `+i);var r=i.find(e=>e===t||t.startsWith(e+"."));return null!=r&&(this.broker.logger.debug("Found settingPopulateField"),this.broker.logger.debug(`Checking if ${r} is in `,e),null==e[r]?(this.broker.logger.debug("No settingPopulateField found, setting to empty array"),this.broker.logger.debug(`Adding ${[t]} to `+e[r]),e[r]=[t]):(this.broker.logger.debug(`Pushing ${t} to `+e[r]),e[r].push(t))),this.broker.logger.debug("Returning "+JSON.stringify(e)),e},{}),o=[];this.broker.logger.debug("Looping through settingPopulateFields...");for(const d of i){this.broker.logger.debug("setting rule to "+this.service.settings.populates[d]);let s=this.service.settings.populates[d];if(null==n[d])this.broker.logger.debug("No groupedPopulateFields found, skipping");else{this.broker.logger.debug("Checking if rule is a function..."),isFunction(s)&&(this.broker.logger.debug("Rule is a function, setting handler"),s={handler:method(s)}),this.broker.logger.debug("Rule is not a function. Checking if rule is a string..."),isString(s)&&(this.broker.logger.debug("Rule is a string, setting action"),s={action:s}),this.broker.logger.debug("Rule is not a string. Checking if rule is undefined.."),void 0===s.field&&(this.broker.logger.debug("Rule is undefined, setting rule.field to "+d),s.field=d),this.broker.logger.debug("Setting arr to docs...");let e=Array.isArray(r)?r:[r];this.broker.logger.debug("Collecting IDs from field of docs, (flatten, compact & unique list) setting idList");var a=uniq(flattenDeep(compact(e.map(e=>get(e,s.field))))),l=(this.broker.logger.debug("Replacing the received models according to IDs in the original docs"),i=>{this.broker.logger.debug("Looping through docs..."),e.forEach(e=>{this.broker.logger.debug("Setting id to "+get(e,s.field));var t,r=get(e,s.field);this.broker.logger.debug("Checking if id is an array..."),isArray(r)?(this.broker.logger.debug("id is an array, setting models to "+compact(r.map(e=>i[e]))),t=compact(r.map(e=>i[e])),this.broker.logger.debug("Setting doc to models..."),set(e,d,t)):(this.broker.logger.debug("id is not an array, setting doc to populatedDocs[id]"),set(e,d,i[r]))})});this.broker.logger.debug("Checking if rule.handler is defined..."),s.handler?(this.broker.logger.debug("rule.handler is defined, calling rule.handler"),o.push(s.handler.call(this,a,e,s,t))):0<a.length&&(this.broker.logger.debug("rule.handler is not defined and idList.length > 0, calling target action & collect the promises"),a=Object.assign({id:a,mapping:!0,populate:[...n[d].map(e=>e.slice(d.length+1)).filter(e=>""!==e),...s.populate||[]]},s.params||{}),this.broker.logger.debug("Checking if params.populate.length === 0..."),0===a.populate.length&&(this.broker.logger.debug("params.populate.length === 0, deleting params.populate"),delete a.populate),this.broker.logger.debug(`Calling ${s.action} with params ${a} then transforming result...`),o.push(t.call(s.action,a).then(l)))}}return this.broker.logger.debug("Returning all promises..."),all(o).then(()=>r)}validateEntity(e){var t;return isFunction(this.service.settings.entityValidator)?(t=Array.isArray(e)?e:[e],all(t.map(e=>this.service.settings.entityValidator.call(this,e))).then(()=>e)):resolve(e)}entityToObject(e){return e}authorizeFields(e){if(this.service.settings.fields&&0<this.service.settings.fields.length){let i=[];return Array.isArray(e)&&0<e.length&&e.forEach(t=>{if(-1!==this.service.settings.fields.indexOf(t))i.push(t);else{if(-1!==t.indexOf("."))for(var e=t.split(".");1<e.length;)if(e.pop(),-1!==this.service.settings.fields.indexOf(e.join(".")))return void i.push(t);var r=this.service.settings.fields.filter(e=>e.startsWith(t+"."));0<r.length&&(i=i.concat(r))}}),i}return e}sanitizeParams(e,t){var r=Object.assign({},t);if("string"==typeof r.limit&&(r.limit=Number(r.limit)),"string"==typeof r.take&&(r.take=Number(r.take)),"string"==typeof r.offset&&(r.offset=Number(r.offset)),"string"==typeof r.skip&&(r.skip=Number(r.skip)),"string"==typeof r.page&&(r.page=Number(r.page)),"string"==typeof r.pageSize&&(r.pageSize=Number(r.pageSize)),"string"==typeof r.query&&(r.query=JSON.parse(r.query)),"string"==typeof r.sort&&(r.sort=r.sort.split(/[,\s]+/)),"string"==typeof r.fields&&(r.fields=r.fields.split(/[,\s]+/)),"string"==typeof r.excludeFields&&(r.excludeFields=r.excludeFields.split(/[,\s]+/)),"string"==typeof r.populate&&(r.populate=r.populate.split(/[,\s]+/)),r?.relations&&("string"==typeof r.relations&&(r.relations=JSON.parse(r.relations)),"object"==typeof r.relations))for(var[i,s]of Object.entries(r.relations))"true"!==s&&"false"!==s||(r.relations[i]=JSON.parse(s));if(r?.where&&("string"==typeof r.where&&(r.where=JSON.parse(r.where)),"object"==typeof r.where))for(var[n,o]of Object.entries(r.where))"true"!==o&&"false"!==o||(r.where[n]=JSON.parse(o));return"string"==typeof r.searchFields&&(r.searchFields=r.searchFields.split(/[,\s]+/)),e.action.name.endsWith(".list")&&(r.pageSize||(r.pageSize=this.service.settings.pageSize),r.page||(r.page=1),0<this.service.settings.maxPageSize&&r.pageSize>this.service.settings.maxPageSize&&(r.pageSize=this.service.settings.maxPageSize),r.limit&&(r.limit=r.pageSize),r.offset&&(r.offset=(r.page-1)*r.pageSize),r.take&&(r.take=r.pageSize),r.skip)&&(r.skip=(r.page-1)*r.pageSize),0<this.service.settings.maxLimit&&r.limit>this.service.settings.maxLimit&&(r.limit=this.service.settings.maxLimit),0<this.service.settings.maxLimit&&r.take>this.service.settings.maxLimit&&(r.take=this.service.settings.maxLimit),r}}const TAdapterServiceSchemaMixin=e=>{return defaultsDeep({name:"",adapter:null,settings:{idField:"_id",fields:null,excludeFields:null,populates:null,pageSize:10,maxPageSize:100,maxLimit:-1,entityValidator:null,useDotNotation:!1,cacheCleanEventType:"broadcast"},actions:{find:{cache:{keys:["populate","fields","excludeFields","limit","offset","sort","search","searchFields","query"]},params:{populate:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],fields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],excludeFields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],take:{type:"number",integer:!0,min:0,optional:!0,convert:!0},skip:{type:"number",integer:!0,min:0,optional:!0,convert:!0},limit:{type:"number",integer:!0,min:0,optional:!0,convert:!0},offset:{type:"number",integer:!0,min:0,optional:!0,convert:!0},sort:{type:"string",optional:!0},search:{type:"string",optional:!0},searchFields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],query:[{type:"object",optional:!0},{type:"string",optional:!0}]},handler(e){e=this.adapter.sanitizeParams(e,e.params);return this._find(e)}},count:{cache:{keys:["search","searchFields","query"]},params:{options:{type:"object",optional:!0},query:{type:"object",optional:!0}},handler(e){e=this.adapter.sanitizeParams(e,e.params);return this.adapter.count(e)}},list:{cache:{keys:["populate","fields","excludeFields","page","pageSize","sort","search","searchFields","query"]},rest:"GET /",params:{populate:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],fields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],excludeFields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],page:{type:"number",integer:!0,min:1,optional:!0,convert:!0},pageSize:{type:"number",integer:!0,min:0,optional:!0,convert:!0},sort:{type:"string",optional:!0},search:{type:"string",optional:!0},searchFields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],query:[{type:"object",optional:!0},{type:"string",optional:!0}]},handler(e){var t=this.sanitizeParams(e,e.params);return this._list(e,t)}},create:{rest:"POST /",params:{entityOrEntities:[{type:"object"},{type:"array"}],options:{type:"object",optional:!0}},handler(e){var t=this.sanitizeParams(e,e.params);return this._create(e,t)}},insert:{rest:"PUT /",params:{entityOrEntities:[{type:"object"},{type:"array"}],options:{type:"object",optional:!0}},handler(e){var t=this.sanitizeParams(e,e.params);return this._insert(e,t)}},get:{cache:{keys:["id","populate","fields","excludeFields","mapping"]},rest:"GET /:id",params:{id:[{type:"string"},{type:"number"},{type:"array"}],populate:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],relations:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],fields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],excludeFields:[{type:"string",optional:!0},{type:"array",optional:!0,items:"string"}],mapping:{type:"boolean",optional:!0}},handler(e){var t=this.sanitizeParams(e,e.params);return this._get(e,null,t)}},update:{rest:"PUT /:id",params:{id:{type:"any"}},handler(e){return this.sanitizeParams(e,e.params),this._update(e,e.params)}},remove:{rest:"DELETE /:id",params:{id:{type:"any"},options:{type:"object",optional:!0}},handler(e){return this._remove(e,e.params)}}},methods:{connect(){return this.adapter.connect().then(()=>{if(isFunction(this.schema.afterConnected))try{return this.schema.afterConnected.call(this)}catch(e){this.logger.error("afterConnected error!",e)}})},disconnect(){if(isFunction(this.adapter.disconnect))return this.adapter.disconnect()},sanitizeParams(e,t){return this.adapter.sanitizeParams(e,t)},getById(e,t=this.settings.idField,r,i){return resolve().then(()=>this.adapter.findById(e,t,i?this.adapter.decodeID(r):r))},beforeEntityChange(e,t,r){return this.adapter.beforeEntityChange(e,t,r)},entityChanged(e,t,r){return this.adapter.entityChanged(e,t,r)},clearCache(){return this.broker[this.settings.cacheCleanEventType]("cache.clean."+this.fullName),this.broker.cacher?this.broker.cacher.clean(this.fullName+".**"):resolve()},transformDocuments(e,t,r){return this.adapter.transformDocuments(e,t,r)},filterFields(e,t){return this.adapter.filterFields(e,t)},excludeFields(e,t){return this.adapter.excludeFields(e,t)},authorizeFields(e){return this.adapter.authorizeFields(e)},populateDocs(e,t,r){return this.adapter.populateDocs(e,t,r)},validateEntity(e){return this.adapter.validateEntity(e)},encodeID(e){return this.adapter.encodeID(e)},decodeID(e){return this.adapter.decodeID(e)},_find(t,r){return this.adapter.find(t,r).then(e=>this.transformDocuments(t,r,e))},_count(e,t){return t&&t.limit&&(t.limit=null),t&&t.offset&&(t.offset=null),this.adapter.count(t)},_list(e,t){return this.adapter.list(e,t)},_create(t,r){const{entityOrEntities:i,options:s}=r;return this.beforeEntityChange("create",i,t).then(async e=>(this.logger.debug("Validating entity(s) to create: "+e),this.validateEntity(e))).then(async e=>(this.logger.debug("Attempting to create entity: "+e),this.adapter.create(t,e,s))).then(async e=>(this.logger.debug("Transforming created entity..."),this.transformDocuments(t,r,e))).then(async e=>this.entityChanged("created",e,t).then(()=>e)).catch(e=>{this.logger.error("Failed to create entity: "+e),new Errors.MoleculerServerError("Failed to create entity(s): "+i,500,"FAILED_TO_CREATE_ENTITY",e)})},_insert(t,e){const{entityOrEntities:r,options:i}=e;return this.beforeEntityChange("create",r,t).then(e=>(this.logger.debug("Validating entity(s) to insert: "+e),this.validateEntity(e))).then(e=>(this.logger.debug("Transforming entity id..."),this.adapter.beforeSaveTransformID(e,this.settings.idField))).then(async e=>(this.logger.debug("Attempting to insert entity: "+e),this.adapter.insert(t,e,i))).then(e=>this.transformDocuments(t,{},e)).then(e=>this.entityChanged("created",e,t).then(()=>e))},_get(e,t=this.settings.idField,i){let r=i.id,s,n=!0===i.mapping;return this.getById(e,t,r,!0).then(e=>e?(s=n?isArray(e)?e.map(e=>cloneDeep(e)):cloneDeep(e):e,e):Promise.reject(new Errors.MoleculerClientError("Entity not found",400,"",r))).then(e=>{if(!0!==i.mapping)return e;let r={};var t;return isArray(e)?e.forEach((e,t)=>{t=this.adapter.encodeID(this.adapter.afterRetrieveTransformID(s[t],this.settings.idField)[this.settings.idField]);r[t]=e}):isObject(e)&&(t=this.adapter.encodeID(this.adapter.afterRetrieveTransformID(s,this.settings.idField)[this.settings.idField]),r[t]=e),r})},_update(t,e){let i;return this.beforeEntityChange("update",e,t).then(t=>{let r={};return Object.keys(t).forEach(e=>{"id"==e||e==this.settings.idField?i=this.decodeID(t[e]):r[e]=t[e]}),r=this.settings.useDotNotation?flatten(r,{safe:!0}):r}).then(async e=>(this.logger.debug(`Updating entity by ID '${i}' with `+JSON.stringify(e)),this.adapter.updateById(t,i,e))).then(e=>this.entityChanged("updated",e,t).then(()=>e)).catch(e=>{this.logger.error("Failed to update: "+e),new Errors.MoleculerServerError("Failed to update "+e,500,"FAILED_TO_UPDATE",e)})},_remove(t,r){const i=this.adapter.decodeID(r.id);let s;return Promise.resolve().then(async()=>s=await this.getById(t,null,i,!0)).then(e=>this.beforeEntityChange("remove",e,t)).then(()=>this.adapter.removeById(i)).then(e=>0===e.deletedCount?Promise.reject(new Errors.MoleculerClientError("Entity not found",400,"",i)):this.transformDocuments(t,r,s).then(e=>this.entityChanged("removed",e,t).then(()=>e)))}},created(){if(isString(this.settings.fields)&&(this.settings.fields=this.settings.fields.split(/\s+/)),isString(this.settings.excludeFields)&&(this.settings.excludeFields=this.settings.excludeFields.split(/\s+/)),this.adapter=this.schema.adapter,this.adapter.init(this.broker,this),this.broker.validator&&isObject(this.settings.entityValidator)&&!isFunction(this.settings.entityValidator)){const r=this.broker.validator.compile(this.settings.entityValidator);this.settings.entityValidator=async e=>{let t=r(e);return!0===(t=!0===r.async||t.then instanceof Function?await t:t)?Promise.resolve():Promise.reject(new Errors.ValidationError("Entity validation error!","",t))}}},started(){return this.adapter?new Promise(e=>{let t=()=>{this.connect().then(e).catch(e=>{this.logger.error("Connection error!",e),setTimeout(()=>{this.logger.warn("Reconnecting..."),t()},1e3)})};t()}):Promise.reject(new Error("Please set the store adapter in schema!"))},stopped(){if(this.adapter)return this.adapter.disconnect()}},e)};export{TAdapterServiceSchemaMixin,TypeORMDbAdapter as default};
